local iLvl = {
  Name = "Easy iLvl",
  Version = "v1.1.1",
  Author = "Rncid@Firetree"
}

local Items = {
  CharacterHeadSlot = 1,
  CharacterNeckSlot = 2,
  CharacterShoulderSlot = 3,
  CharacterBackSlot = 15,
  CharacterChestSlot = 5,
--  CharacterShirtSlot = 4,
--  CharacterTabardSlot = 19,
  CharacterWristSlot = 9,
  CharacterHandsSlot = 10,
  CharacterWaistSlot = 6,
  CharacterLegsSlot = 7,
  CharacterFeetSlot = 8,
  CharacterFinger0Slot = 11,
  CharacterFinger1Slot = 12,
  CharacterTrinket0Slot = 13,
  CharacterTrinket1Slot = 14,
  CharacterMainHandSlot = 16,
  CharacterSecondaryHandSlot = 17,
  CharacterRangedSlot = 18,
  CharacterAmmoSlot = 0
}

local function p(msg)
  DEFAULT_CHAT_FRAME:AddMessage(msg);
end

local frame = CreateFrame("FRAME", "iLvlFrame");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("UNIT_INVENTORY_CHANGED");

function iLvl_OnEvent(self, event, arg1)
 if event == "PLAYER_ENTERING_WORLD" then
   p("[ |cCC3333ff"..iLvl.Name.."|r ] "..iLvl.Version.." Loaded.", true);
 end
 
 if event == "UNIT_INVENTORY_CHANGED" then
   if arg1 == "player" then
     iLvl_Update();
   end
 end
end

frame:SetScript("OnEvent", iLvl_OnEvent);

function iLvl_Update()
  local tCount = 0;
  local tSlots = 17;

  for Key, Value in pairs(Items) do
    local ItemLink = GetInventoryItemLink("player", Value)
    
    local Slot = getglobal(Key.."Stock");
    
    if Slot then
      Slot:Hide();
      if ItemLink then
        local _, _, _, ItemLevel, _, _, ItemSubType, StackCount = GetItemInfo(ItemLink)
        local t = "";

        if ItemSubType ~= nil then
          t = strsub(ItemSubType,0,3)
        end
        
        if Value == 16 and (t == "Two" or t == "Pol" or t == "Sta") then
          tSlots = 16;
        end

	if StackCount == 1 then
	  tCount = tCount + ItemLevel;
          Slot:SetText(ItemLevel);
          Slot:Show();
        end
      end
    end
  end

  return math.floor(tCount/tSlots);
end


function iLvl_PaperDollFrame_SetCurrentItemLevel(statFrame, unit)
  PaperDollFrame_SetLabelAndText(statFrame, "Current Item Level:",iLvl_Update(),false);
  statFrame:Show();
end


PAPERDOLL_STATINFO["CURRENTITEMLEVEL"] = {
  updateFunc = function(statFrame, unit) iLvl_PaperDollFrame_SetCurrentItemLevel(statFrame, unit); end
}

table.insert(PAPERDOLL_STATCATEGORIES["GENERAL"].stats,"CURRENTITEMLEVEL");